

Imports System.Threading
Imports LC.Threading

Public Partial Class InputDevice
	Inherits MidiDevice

    Public Sub New(ByVal deviceID As Integer)
        MyBase.New(deviceID)
        m_midiInProc = AddressOf HandleMessage

        Dim result As Integer = midiInOpen(m_handle, deviceID, m_midiInProc, 0, CALLBACK_FUNCTION)

        If result = MidiDeviceException.MMSYSERR_NOERROR Then
            delegateQueue = New DelegateQueue()
        Else
            Throw New InputDeviceException(result)
        End If
    End Sub

    Protected Overrides Sub Finalize()
        Try
            If Not IsDisposed Then
                midiInReset(m_handle)
                midiInClose(m_handle)
            End If
        Finally
            MyBase.Finalize()
        End Try
    End Sub

End Class
