

Imports System.Diagnostics
Imports System.Threading
Imports LC.Multimedia

Public Partial Class InputDevice
	Public Overloads Overrides Sub Close()
        If IsDisposed Then
            Return
        End If
        Dispose(True)
    End Sub

	Public Sub StartRecording()
        If IsDisposed Then
            Throw New ObjectDisposedException("InputDevice")
        End If

        If recording Then
            Return
        End If

        SyncLock lockObject
            Dim result As Integer = AddSysExBuffer()

            If result = DeviceException.MMSYSERR_NOERROR Then
                result = AddSysExBuffer()
            End If
            If result = DeviceException.MMSYSERR_NOERROR Then
                result = AddSysExBuffer()
            End If
            If result = DeviceException.MMSYSERR_NOERROR Then
                result = AddSysExBuffer()
            End If
            If result = DeviceException.MMSYSERR_NOERROR Then
                result = midiInStart(m_handle)
            End If
            If result = MidiDeviceException.MMSYSERR_NOERROR Then
                recording = True
            Else
                Throw New InputDeviceException(result)
            End If
        End SyncLock
    End Sub

	Public Sub StopRecording()
        If IsDisposed Then
            Throw New ObjectDisposedException("InputDevice")
        End If
        If Not recording Then
            Return
        End If
        SyncLock lockObject
            Dim result As Integer = midiInStop(m_handle)

            If result = MidiDeviceException.MMSYSERR_NOERROR Then
                recording = False
            Else
                Throw New InputDeviceException(result)
            End If
        End SyncLock
    End Sub

	Public Overloads Overrides Sub Reset()
        If IsDisposed Then
            Throw New ObjectDisposedException("InputDevice")
        End If
        SyncLock lockObject
            resetting = True
            Dim result As Integer = midiInReset(m_handle)

            If result = MidiDeviceException.MMSYSERR_NOERROR Then
                recording = False
                While bufferCount > 0
                    Monitor.Wait(lockObject)
                End While
                resetting = False
            Else
                resetting = False
                Throw New InputDeviceException(result)
            End If
        End SyncLock
    End Sub

	Public Shared Function GetDeviceCapabilities(deviceID As Integer) As MidiInCaps
		Dim result As Integer
		Dim caps As New MidiInCaps()
		result = midiInGetDevCaps(deviceID, caps, SizeOfMidiHeader)

		If result <> MidiDeviceException.MMSYSERR_NOERROR Then
			Throw New InputDeviceException(result)
		End If
		Return caps
	End Function

	Public Overloads Overrides Sub Dispose()
        If IsDisposed Then
            Return
        End If
        Dispose(True)
    End Sub

End Class
