

Public Class MonoToStereoConverter
	Inherits StereoSynthComponent
	Private input As MonoSynthComponent

	Private m_synthesizeReplaceEnabled As Boolean = True

	Public Sub New(sampleRate As SampleRate, buffer As StereoBuffer, input As MonoSynthComponent)
		MyBase.New(sampleRate, buffer)
		If input Is Nothing Then
			Throw New ArgumentNullException("input")
		End If
		Me.input = input
	End Sub

	Public Sub New(sampleRate As SampleRate, buffer As StereoBuffer, name As String, input As MonoSynthComponent)
		MyBase.New(sampleRate, buffer, name)
		If input Is Nothing Then
			Throw New ArgumentNullException("input")
		End If
		Me.input = input
	End Sub

	Public Overloads Overrides Sub Synthesize(offset As Integer, count As Integer)
		Dim buffer As Single(,) = GetBuffer()
		Dim inputBuffer As Single() = input.GetBuffer()
		Dim c As Integer = offset + count

		If SynthesizeReplaceEnabled Then
			For i As Integer = offset To c - 1
				buffer(0, i) = inputBuffer(i)
				buffer(1, i) = inputBuffer(i)
			Next
		Else
			For i As Integer = offset To c - 1
				buffer(0, i) += inputBuffer(i)
				buffer(1, i) += inputBuffer(i)
			Next
		End If
	End Sub

	Public Overloads Overrides Sub Trigger(previousNote As Integer, note As Integer, velocity As Single)
	End Sub

	Public Overloads Overrides Sub Release(velocity As Single)
	End Sub

	Public Overloads Overrides ReadOnly Property Ordinal() As Integer
		Get
			Return 1 + input.Ordinal
		End Get
	End Property

	Public Overloads Overrides Property SynthesizeReplaceEnabled() As Boolean
		Get
			Return m_synthesizeReplaceEnabled
		End Get
		Set
			m_synthesizeReplaceEnabled = value
		End Set
    End Property

End Class
