

Imports System.Windows.Forms

Namespace UI

    Partial Public Class OutputDeviceDialog
        Inherits Form

        Private m_deviceId As Integer = 0

        Public Sub New()
            InitializeComponent()

            If OutputDevice.DeviceCount > 0 Then
                Dim caps As WaveOutCaps
                For i As Integer = 0 To OutputDevice.DeviceCount - 1
                    caps = OutputDevice.GetDeviceCapabilities(i)
                    devicesComboBox.Items.Add(caps.name)
                Next
                devicesComboBox.SelectedIndex = m_deviceId
            End If
        End Sub

        Protected Overloads Overrides Sub OnShown(ByVal e As EventArgs)
            devicesComboBox.SelectedIndex = m_deviceId
            MyBase.OnShown(e)
        End Sub

        Private Sub okButton_Click(ByVal sender As Object, ByVal e As EventArgs)
            m_deviceId = devicesComboBox.SelectedIndex
        End Sub

        Public Property DeviceId() As Integer
            Get
                Return m_deviceId
            End Get
            Set(ByVal value As Integer)
                If value < 0 OrElse value >= OutputDevice.DeviceCount Then
                    Throw New ArgumentOutOfRangeException("value")
                End If
                m_deviceId = value
            End Set
        End Property

    End Class

End Namespace
