﻿
Imports System.Collections.Generic
Imports LC.Synth
Imports LC.Midi

Partial Public Class Form1
    Friend synth1 As Synthesizer
    Private editing As Boolean = False
    Private updating As Boolean = False
    Private _controls As Control()
    'Private WithEvents midiInputDevice As InputDevice
    Private Vumeter1 As VuMeter
    Private Vumeter2 As VuMeter

    Private Sub InitSynthEditor(ByVal s As Synthesizer)
        ' ----------------------------------------------------------------- init and show controls
        _controls = New Control(s.ParameterCount - 1) {}
        InitializeControls()
        UpdateControls()
        ' ----------------------------------------------------------------- init callback handlers
        AddHandler s.ParameterChanged, AddressOf HandleParameterChanged
        AddHandler s.ProgramLoaded, AddressOf HandleProgramLoaded
        AddHandler s.BankLoaded, AddressOf HandleBankLoaded
        AddHandler s.SelectedProgramIndexChanged, AddressOf HandleSelectedProgramIndexChanged
        AddHandler s.BufferPlayed, AddressOf HandleBufferPlayed
        'AddHandler s.PlayingStarted, Function(sender2 As Object, e2 As EventArgs) ToolStripStatusLabel1.Text = "Playing..."
        'AddHandler s.PlayingStopped, Function(sender2 As Object, e2 As EventArgs) ToolStripStatusLabel1.Text = "Stopped"
        Vumeter1 = New VuMeter(PBox_VuLeft)
        Vumeter2 = New VuMeter(PBox_VuRight)
    End Sub

    'Private Sub midiInputDevice_ChannelMessageReceived(ByVal sender As Object, ByVal e As LC.Midi.ChannelMessageEventArgs) Handles midiInputDevice.ChannelMessageReceived
    '    Static LastNote As Int32
    '    Select Case e.Message.Command
    '        ' ------------------------------------------------------------- select synt for ProgramChange
    '        Case ChannelCommand.ProgramChange
    '            If LastNote < SplitNote Then
    '                ResetFinalVolume_ToTrackbarValue()
    '                synth1.SetSelectedProgramIndex(e.Message.Data1)
    '                ListBox_Programs.SelectedIndex = e.Message.Data1
    '            Else
    '                ' must reset synth2 volume to track bar before change bank
    '                synth2.SetSelectedProgramIndex(e.Message.Data1)
    '                ListBox_Programs_2.SelectedIndex = e.Message.Data1
    '            End If
    '            ' --------------------------------------------------------- select synt for NoteOn / Note Off
    '        Case ChannelCommand.NoteOn, ChannelCommand.NoteOff
    '            LastNote = e.Message.Data1
    '            If e.Message.Data1 < SplitNote Then
    '                synth1.ProcessChannelMessage(e.Message)
    '            Else
    '                synth2.ProcessChannelMessage(e.Message)
    '            End If
    '            ' --------------------------------------------------------- broadcast all other messages
    '        Case Else
    '            synth1.ProcessChannelMessage(e.Message)
    '            synth2.ProcessChannelMessage(e.Message)
    '    End Select
    '    ' ----------------------------------------------------------------- SHOW MIDI EVENTS
    '    ShowMidiEvents(e)
    'End Sub

    'Private Sub InitMidiInput()
    '    Dim caps As MidiInCaps
    '    Dim deviceID As Int32 = 0
    '    caps = InputDevice.GetDeviceCapabilities(deviceID)
    '    Try
    '        midiInputDevice = New InputDevice(0)
    '        midiInputDevice.StartRecording()
    '    Catch
    '    End Try
    'End Sub

    'Private Sub CloseMidiInput()
    '   If midiInputDevice IsNot Nothing Then
    '       midiInputDevice.Dispose()
    '       midiInputDevice.Close()
    '   End If
    'End Sub


    ' ====================================================================================================
    '  PROGRAM LISTS
    ' ====================================================================================================
    Private Sub ListBox_Programs_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox_Programs.SelectedIndexChanged
        If Not updating Then
            Dim index As Integer = ListBox_Programs.SelectedIndex
            ' ----------------------------------------------- If a program has been selected.
            If index >= 0 Then
                ' ------------------------------------------- Set the Synthesizer to the new program.
                synth1.SetSelectedProgramIndex(index)
                PlayingNotes_ReleaseAllNotes()
                ' ------------------------------------------- Update the controls to reflect the values of the selected program.
                UpdateControls()
            End If
        End If
    End Sub

    Private Sub FillProgramList()
        ListBox_Programs.Items.Clear()
        For i As Integer = 0 To synth1.ProgramCount - 1
            ListBox_Programs.Items.Add(synth1.GetProgramName(i))
        Next
        updating = True
        ListBox_Programs.SelectedIndex = synth1.SelectedProgramIndex
        updating = False
    End Sub

    Delegate Sub SelectNextVoiceDelegate()
    Private Sub SelectNextVoice()
        Dim index As Integer = ListBox_Programs.SelectedIndex
        If index < ListBox_Programs.Items.Count - 1 Then
            ListBox_Programs.SelectedIndex += 1
        End If
    End Sub
    Private Sub SelectNextVoice_ThreadSafe()
        If ListBox_Programs.InvokeRequired Then
            Me.Invoke(New SelectNextVoiceDelegate(AddressOf SelectNextVoice))
        Else
            SelectNextVoice()
        End If
    End Sub

    Delegate Sub SelectLastVoiceDelegate()
    Private Sub SelectLastVoice()
        Dim index As Integer = ListBox_Programs.SelectedIndex
        If index > 0 Then
            ListBox_Programs.SelectedIndex -= 1
        End If
    End Sub
    Private Sub SelectLastVoice_ThreadSafe()
        If ListBox_Programs.InvokeRequired Then
            Me.Invoke(New SelectLastVoiceDelegate(AddressOf SelectLastVoice))
        Else
            SelectLastVoice()
        End If
    End Sub

    Private VoiceToBeSelected As Int32
    Delegate Sub SelectVoiceDelegate()
    Private Sub SelectVoice()
        If VoiceToBeSelected >= 0 And VoiceToBeSelected < ListBox_Programs.Items.Count Then
            ListBox_Programs.SelectedIndex = VoiceToBeSelected
        End If
    End Sub
    Private Sub SelectVoice_ThreadSafe()
        If ListBox_Programs.InvokeRequired Then
            Me.Invoke(New SelectVoiceDelegate(AddressOf SelectVoice))
        Else
            SelectVoice()
        End If
    End Sub


    ' ====================================================================================================
    '  PIANO KEYBOARD
    ' ====================================================================================================
    Private KeyboardChannel As Int32 = 0
    Private KeyboardVelocity As Int32 = 120
    Private Sub pianoControl1_PianoKeyDown(ByVal sender As Object, ByVal e As LC.Midi.UI.PianoKeyEventArgs) Handles pianoControl1.PianoKeyDown
        If Not EventsAreEnabled Then Return
        Dim message As ChannelMessage = New ChannelMessage(ChannelCommand.NoteOn, KeyboardChannel, e.NoteID, KeyboardVelocity)
        synth1.ProcessChannelMessage(message)
        MidiOutSendMessage(message)
        'Debug.Print(e.NoteID.ToString)
    End Sub
    Private Sub pianoControl1_PianoKeyUp(ByVal sender As Object, ByVal e As LC.Midi.UI.PianoKeyEventArgs) Handles pianoControl1.PianoKeyUp
        If Not EventsAreEnabled Then Return
        Dim message As ChannelMessage = New ChannelMessage(ChannelCommand.NoteOff, KeyboardChannel, e.NoteID)
        synth1.ProcessChannelMessage(message)
        MidiOutSendMessage(message)
        '
        ' ------------------------- avoid stop theremin if arrow passes over the keybord
        PlayingNotes_Release(e.NoteID)
        ' -------------------------------------------------------------------------------
    End Sub


    ' ====================================================================================================
    '  MIDI EVENTS LIST
    ' ====================================================================================================
    'Private Sub ShowMidiEvents(ByVal e As LC.Midi.ChannelMessageEventArgs)
    '    If CheckBox_DisplayEvents.Checked Then
    '        Dim s As String = RSet(Hex(e.Message.Message), 6) & _
    '                            " d1=" & e.Message.Data1 & _
    '                            " d2=" & e.Message.Data2 & _
    '                            " ch=" & e.Message.MidiChannel & _
    '                            " " & e.Message.Command.ToString

    '        TextBox_MidiEvents.Text &= s & vbCrLf
    '    End If
    'End Sub
    'Private Sub Button_CopyEventsToClipBoard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_CopyEventsToClipBoard.Click
    '    Clipboard.SetData(System.Windows.Forms.DataFormats.Text, TextBox_MidiEvents.Text)
    '    Beep()
    'End Sub
    'Private Sub Button_ClearAllEvents_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_ClearAllEvents.Click
    '    TextBox_MidiEvents.Text = Nothing
    'End Sub


    ' ====================================================================================================
    '   CREATE SYNT
    ' ====================================================================================================
    Private Function CreateSynthesizer(ByVal deviceId As Integer, ByVal bufferSize As Integer, ByVal sampleRate As Integer) As Synthesizer
        '
        ' --------------------------------------------------- create Lite Wave synthesizer
        Dim _voiceFactory As VoiceFactory
        _voiceFactory = AddressOf VoiceFactory_Delegate
        '_voiceFactory = New VoiceFactory(AddressOf VoiceFactory_Delegate)
        '_voiceFactory = New VoiceFactory(Function(sr As SampleRate, buffer As StereoBuffer, name As String) New SynthVB_Voice(sr, buffer, name))
        '_voiceFactory = Function(sr As SampleRate, buffer As StereoBuffer, name As String) New SynthVB_Voice(sr, buffer, name)

        Dim _effectFactory As EffectFactory
        _effectFactory = AddressOf EffectFactory_Delegate
        '_effectFactory = New EffectFactory(AddressOf EffectFactory_Delegate)
        '_effectFactory = Function(sr As SampleRate, buffer As StereoBuffer) New EffectComponent() {New Chorus(sr, buffer), New Echo(sr, buffer)}

        Return New Synthesizer("Lite Wave", _
                                deviceId, _
                                bufferSize, _
                                sampleRate, _
                                _voiceFactory, _
                                8, _
                                _effectFactory)
    End Function

    Private Function VoiceFactory_Delegate(ByVal sr As SampleRate, ByVal buffer As StereoBuffer, ByVal name As String) As SynthVB_Voice
        Dim Voice As SynthVB_Voice
        Voice = New SynthVB_Voice(sr, buffer, name)
        Return Voice
    End Function

    Private Function EffectFactory_Delegate(ByVal sr As SampleRate, ByVal inputBuffer As StereoBuffer) As List(Of EffectComponent)
        Dim myEffects As New List(Of EffectComponent)()
        myEffects.Add(New LC.Synth.Chorus(sr, inputBuffer))
        myEffects.Add(New LC.Synth.Echo(sr, inputBuffer))
        Return myEffects
    End Function



    ' ====================================================================================================
    '  EDIT CONTROLS
    ' ====================================================================================================
    Private BankModifyed As Boolean = False

    Private Sub InitializeControls()

        For i As Integer = 0 To synth1.ParameterCount - 1
            Dim name As String = synth1.GetParameterName(i)

            Select Case name
                Case "Amplitude"
                    amplitudeTrackBar.Tag = i
                    _controls(i) = amplitudeTrackBar

                Case "Pitch Bend Range"
                    pitchBendRangeNnumericUpDown.Tag = i
                    _controls(i) = pitchBendRangeNnumericUpDown

                Case "Polyphony Mode"
                    polyphonyCheckBox.Tag = i
                    _controls(i) = polyphonyCheckBox

                Case "Oscillator 1 Amplitude Level"
                    osc1LevelTrackBar.Tag = i
                    _controls(i) = osc1LevelTrackBar

                Case "Oscillator 1 Transpose"
                    osc1TransposeNumericUpDown.Tag = i
                    _controls(i) = osc1TransposeNumericUpDown

                Case "Oscillator 1 Detune"
                    osc1DetuneNumericUpDown.Tag = i
                    _controls(i) = osc1DetuneNumericUpDown

                Case "Oscillator 1 Waveform"
                    osc1WaveComboBox.Tag = i
                    _controls(i) = osc1WaveComboBox

                Case "Oscillator 1 Polarity"
                    osc1PolarityCheckBox.Tag = i
                    _controls(i) = osc1PolarityCheckBox

                Case "Oscillator 1 FM Polarity"
                    osc1FMPolarityCheckBox.Tag = i
                    _controls(i) = osc1FMPolarityCheckBox

                Case "Oscillator 1 FM Source"
                    osc1FMSourceComboBox.Tag = i
                    _controls(i) = osc1FMSourceComboBox

                Case "Oscillator 1 FM Level"
                    osc1FMLevelTrackBar.Tag = i
                    _controls(i) = osc1FMLevelTrackBar

                Case "Oscillator 1 Portamento Enabled"
                    osc1PortamentoCheckBox.Tag = i
                    _controls(i) = osc1PortamentoCheckBox

                Case "Oscillator 2 Amplitude Level"
                    osc2LevelTrackBar.Tag = i
                    _controls(i) = osc2LevelTrackBar

                Case "Oscillator 2 Transpose"
                    osc2TransposeNumericUpDown.Tag = i
                    _controls(i) = osc2TransposeNumericUpDown

                Case "Oscillator 2 Detune"
                    osc2DetuneNumericUpDown.Tag = i
                    _controls(i) = osc2DetuneNumericUpDown

                Case "Oscillator 2 Waveform"
                    osc2WaveComboBox.Tag = i
                    _controls(i) = osc2WaveComboBox

                Case "Oscillator 2 Polarity"
                    osc2PolarityCheckBox.Tag = i
                    _controls(i) = osc2PolarityCheckBox

                Case "Oscillator 2 FM Polarity"
                    osc2FMPolarityCheckBox.Tag = i
                    _controls(i) = osc2FMPolarityCheckBox

                Case "Oscillator 2 FM Source"
                    osc2FMSourceComboBox.Tag = i
                    _controls(i) = osc2FMSourceComboBox

                Case "Oscillator 2 FM Level"
                    osc2FMLevelTrackBar.Tag = i
                    _controls(i) = osc2FMLevelTrackBar

                Case "Oscillator 2 Portamento Enabled"
                    osc2PortamentoCheckBox.Tag = i
                    _controls(i) = osc2PortamentoCheckBox

                Case "State Variable Filter Filter Type"
                    filterTypeComboBox.Tag = i
                    _controls(i) = filterTypeComboBox

                Case "State Variable Filter Cutoff Frequency"
                    filterFrequencyTrackBar.Tag = i
                    _controls(i) = filterFrequencyTrackBar

                Case "State Variable Filter Resonance"
                    filterResonanceTrackBar.Tag = i
                    _controls(i) = filterResonanceTrackBar

                Case "State Variable Filter Keyboard Tracking"
                    filterTrackingTrackBar.Tag = i
                    _controls(i) = filterTrackingTrackBar

                Case "State Variable Filter FM 1 Level"
                    filterEnv2FMLevelTrackBar.Tag = i
                    _controls(i) = filterEnv2FMLevelTrackBar

                Case "State Variable Filter FM 1 Polarity"
                    filterEnv2PolarityCheckBox.Tag = i
                    _controls(i) = filterEnv2PolarityCheckBox

                Case "State Variable Filter FM 2 Level"
                    filterLfo2FMLeveltrackBar.Tag = i
                    _controls(i) = filterLfo2FMLeveltrackBar

                Case "State Variable Filter FM 2 Polarity"
                    filterLfo2FMPolarityCheckBox.Tag = i
                    _controls(i) = filterLfo2FMPolarityCheckBox

                Case "State Variable Filter Drive"
                    filterDriveLevelTrackBar.Tag = i
                    _controls(i) = filterDriveLevelTrackBar

                Case "Envelope 1 Attack Time"
                    env1AttackTrackBar.Tag = i
                    _controls(i) = env1AttackTrackBar

                Case "Envelope 1 Decay Time"
                    env1DecayTrackBar.Tag = i
                    _controls(i) = env1DecayTrackBar

                Case "Envelope 1 Sustain Level"
                    env1SustainTrackBar.Tag = i
                    _controls(i) = env1SustainTrackBar

                Case "Envelope 1 Release Time"
                    env1ReleaseTrackBar.Tag = i
                    _controls(i) = env1ReleaseTrackBar

                Case "Envelope 1 Velocity Sensitivity"
                    env1VelocityTrackBar.Tag = i
                    _controls(i) = env1VelocityTrackBar

                Case "Envelope 1 Trigger Mode"
                    env1LegatoCheckBox.Tag = i
                    _controls(i) = env1LegatoCheckBox

                Case "Envelope 2 Attack Time"
                    env2AttackTrackBar.Tag = i
                    _controls(i) = env2AttackTrackBar

                Case "Envelope 2 Decay Time"
                    env2DecayTrackBar.Tag = i
                    _controls(i) = env2DecayTrackBar

                Case "Envelope 2 Sustain Level"
                    env2SustainTrackBar.Tag = i
                    _controls(i) = env2SustainTrackBar

                Case "Envelope 2 Release Time"
                    env2ReleaseTrackBar.Tag = i
                    _controls(i) = env2ReleaseTrackBar

                Case "Envelope 2 Velocity Sensitivity"
                    env2VelocityTrackBar.Tag = i
                    _controls(i) = env2VelocityTrackBar

                Case "Envelope 2 Trigger Mode"
                    env2LegatoCheckBox.Tag = i
                    _controls(i) = env2LegatoCheckBox

                Case "LFO 1 Shape"
                    lfo1ShapeComboBox.Tag = i
                    _controls(i) = lfo1ShapeComboBox

                Case "LFO 1 Speed"
                    lfo1SpeedTrackBar.Tag = i
                    _controls(i) = lfo1SpeedTrackBar

                Case "LFO 1 Delay"
                    lfo1DelayTrackBar.Tag = i
                    _controls(i) = lfo1DelayTrackBar

                Case "LFO 1 Modulation Wheel Enabled"
                    lfo1ModWheelCheckBox.Tag = i
                    _controls(i) = lfo1ModWheelCheckBox

                Case "LFO 2 Shape"
                    lfo2ShapeComboBox.Tag = i
                    _controls(i) = lfo2ShapeComboBox

                Case "LFO 2 Speed"
                    lfo2SpeedTrackBar.Tag = i
                    _controls(i) = lfo2SpeedTrackBar

                Case "LFO 2 Delay"
                    lfo2DelayTrackBar.Tag = i
                    _controls(i) = lfo2DelayTrackBar

                Case "LFO 2 Modulation Wheel Enabled"
                    lfo2ModWheelCheckBox.Tag = i
                    _controls(i) = lfo2ModWheelCheckBox

                Case "Portamento Time"
                    portamentoTimeTrackBar.Tag = i
                    _controls(i) = portamentoTimeTrackBar

                Case "Chorus WetDryMix"
                    chorusMixTrackBar.Tag = i
                    _controls(i) = chorusMixTrackBar

                Case "Chorus Delay"
                    chorusDelayTrackBar.Tag = i
                    _controls(i) = chorusDelayTrackBar

                Case "Chorus Depth"
                    chorusDepthTrackBar.Tag = i
                    _controls(i) = chorusDepthTrackBar

                Case "Chorus Feedback"
                    chorusFeedbackTrackBar.Tag = i
                    _controls(i) = chorusFeedbackTrackBar

                Case "Chorus Frequency"
                    chorusFrequencyTrackBar.Tag = i
                    _controls(i) = chorusFrequencyTrackBar

                Case "Chorus Phase"
                    chorusPhaseComboBox.Tag = i
                    _controls(i) = chorusPhaseComboBox

                Case "Chorus Waveform"
                    chorusWaveformComboBox.Tag = i
                    _controls(i) = chorusWaveformComboBox

                Case "Echo Feedback"
                    echoFeedbackTrackBar.Tag = i
                    _controls(i) = echoFeedbackTrackBar

                Case "Echo LeftDelay"
                    echoLeftDelayTrackBar.Tag = i
                    _controls(i) = echoLeftDelayTrackBar

                Case "Echo RightDelay"
                    echoRightDelayTrackBar.Tag = i
                    _controls(i) = echoRightDelayTrackBar

                Case "Echo WetDryMix"
                    echoMixTrackBar.Tag = i
                    _controls(i) = echoMixTrackBar

                Case "Echo PanDelay"
                    echoPanDelayCheckBox.Tag = i
                    _controls(i) = echoPanDelayCheckBox

            End Select
        Next

        For Each name As String In [Enum].GetNames(GetType(OscWaveProgrammer.WaveformType))
            osc1WaveComboBox.Items.Add(name)
            osc2WaveComboBox.Items.Add(name)
        Next

    End Sub

    Private Sub HandleParameterChanged(ByVal sender As Object, ByVal e As ParameterChangedEventArgs)
        If editing Then Return
        UpdateControl(e.Index, e.Value)
    End Sub

    Private Sub HandleProgramLoaded(ByVal sender As Object, ByVal e As EventArgs)
        UpdateControls()
    End Sub

    Private Sub HandleBankLoaded(ByVal sender As Object, ByVal e As EventArgs)
        UpdateControls()
    End Sub

    Private Sub HandleSelectedProgramIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        UpdateControls()
    End Sub

    Private Sub HandleBufferPlayed(ByVal sender As Object, ByVal e As BufferPlayedEventArgs)
        VuMeterLeft_Value = e.LeftPeak
        VuMeterRight_Value = e.RightPeak
    End Sub


    Private Sub HandleTrackBarScroll(ByVal sender As Object, ByVal e As EventArgs) _
                                                                    Handles portamentoTimeTrackBar.Scroll, _
                                                                            osc2LevelTrackBar.Scroll, _
                                                                            osc2FMLevelTrackBar.Scroll, _
                                                                            osc1LevelTrackBar.Scroll, _
                                                                            osc1FMLevelTrackBar.Scroll, _
                                                                            lfo2SpeedTrackBar.Scroll, _
                                                                            lfo2DelayTrackBar.Scroll, _
                                                                            lfo1SpeedTrackBar.Scroll, _
                                                                            lfo1DelayTrackBar.Scroll, _
                                                                            filterTrackingTrackBar.Scroll, _
                                                                            filterResonanceTrackBar.Scroll, _
                                                                            filterLfo2FMLeveltrackBar.Scroll, _
                                                                            filterFrequencyTrackBar.Scroll, _
                                                                            filterEnv2FMLevelTrackBar.Scroll, _
                                                                            filterDriveLevelTrackBar.Scroll, _
                                                                            env2VelocityTrackBar.Scroll, _
                                                                            env2SustainTrackBar.Scroll, _
                                                                            env2ReleaseTrackBar.Scroll, _
                                                                            env2DecayTrackBar.Scroll, _
                                                                            env2AttackTrackBar.Scroll, _
                                                                            env1VelocityTrackBar.Scroll, _
                                                                            env1SustainTrackBar.Scroll, _
                                                                            env1ReleaseTrackBar.Scroll, _
                                                                            env1DecayTrackBar.Scroll, _
                                                                            env1AttackTrackBar.Scroll, _
                                                                            echoRightDelayTrackBar.Scroll, _
                                                                            echoMixTrackBar.Scroll, _
                                                                            echoLeftDelayTrackBar.Scroll, _
                                                                            echoFeedbackTrackBar.Scroll, _
                                                                            chorusMixTrackBar.Scroll, _
                                                                            chorusFrequencyTrackBar.Scroll, _
                                                                            chorusFeedbackTrackBar.Scroll, _
                                                                            chorusDepthTrackBar.Scroll, _
                                                                            chorusDelayTrackBar.Scroll, _
                                                                            amplitudeTrackBar.Scroll
        If updating Then Return
        If synth1 Is Nothing Then Return

        Dim trackBar As TrackBar = DirectCast(sender, TrackBar)
        Dim range As Integer = trackBar.Maximum - trackBar.Minimum

        If range > 0 Then
            Dim index As Integer = CInt(trackBar.Tag)
            Dim value As Single = CSng(trackBar.Value - trackBar.Minimum) / range

            editing = True
            synth1.SetParameterValue(index, value)
            editing = False
        End If

        Set_SoundBankModifyed_Flag()
    End Sub

    Private Sub HandleNumericUpDownValueChanged(ByVal sender As Object, ByVal e As EventArgs) _
                                                                    Handles pitchBendRangeNnumericUpDown.ValueChanged, _
                                                                            osc2TransposeNumericUpDown.ValueChanged, _
                                                                            osc2DetuneNumericUpDown.ValueChanged, _
                                                                            osc1TransposeNumericUpDown.ValueChanged, _
                                                                            osc1DetuneNumericUpDown.ValueChanged
        If updating Then Return
        If synth1 Is Nothing Then Return

        Dim numericUpDown As NumericUpDown = DirectCast(sender, NumericUpDown)
        Dim range As Integer = CInt((numericUpDown.Maximum - numericUpDown.Minimum))

        If range > 0 Then
            Dim index As Integer = CInt(numericUpDown.Tag)
            Dim value As Single = CSng((numericUpDown.Value - numericUpDown.Minimum)) / range

            editing = True
            synth1.SetParameterValue(index, value)
            editing = False
        End If

        Set_SoundBankModifyed_Flag()
    End Sub

    Private Sub HandleCheckBoxCheckedChanged(ByVal sender As Object, ByVal e As EventArgs) _
                                                                    Handles polyphonyCheckBox.CheckedChanged, _
                                                                            osc2PortamentoCheckBox.CheckedChanged, _
                                                                            osc2PolarityCheckBox.CheckedChanged, _
                                                                            osc2FMPolarityCheckBox.CheckedChanged, _
                                                                            osc1PortamentoCheckBox.CheckedChanged, _
                                                                            osc1PolarityCheckBox.CheckedChanged, _
                                                                            osc1FMPolarityCheckBox.CheckedChanged, _
                                                                            lfo2ModWheelCheckBox.CheckedChanged, _
                                                                            lfo1ModWheelCheckBox.CheckedChanged, _
                                                                            filterLfo2FMPolarityCheckBox.CheckedChanged, _
                                                                            filterEnv2PolarityCheckBox.CheckedChanged, _
                                                                            env2LegatoCheckBox.CheckedChanged, _
                                                                            env1LegatoCheckBox.CheckedChanged, _
                                                                            echoPanDelayCheckBox.CheckedChanged
        If updating Then Return
        If synth1 Is Nothing Then Return

        Dim checkBox As CheckBox = DirectCast(sender, CheckBox)
        Dim index As Integer = CInt(checkBox.Tag)

        If checkBox.Checked Then
            editing = True
            synth1.SetParameterValue(index, 1)
            editing = False
        Else
            editing = True
            synth1.SetParameterValue(index, 0)
            editing = False
        End If

        Set_SoundBankModifyed_Flag()
    End Sub

    Private Sub HandleComboBoxSelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) _
                                                                    Handles osc2WaveComboBox.SelectedIndexChanged, _
                                                                            osc2FMSourceComboBox.SelectedIndexChanged, _
                                                                            osc1WaveComboBox.SelectedIndexChanged, _
                                                                            osc1FMSourceComboBox.SelectedIndexChanged, _
                                                                            lfo2ShapeComboBox.SelectedIndexChanged, _
                                                                            lfo1ShapeComboBox.SelectedIndexChanged, _
                                                                            filterTypeComboBox.SelectedIndexChanged, _
                                                                            chorusWaveformComboBox.SelectedIndexChanged, _
                                                                            chorusPhaseComboBox.SelectedIndexChanged
        If updating Then Return
        If synth1 Is Nothing Then Return

        Dim comboBox As ComboBox = DirectCast(sender, ComboBox)
        Dim index As Integer = CInt(comboBox.Tag)
        Dim count As Integer = comboBox.Items.Count
        Dim value As Single

        If count > 1 Then
            value = CSng(comboBox.SelectedIndex) / (count - 1)
        Else
            value = 0
        End If

        editing = True
        synth1.SetParameterValue(index, value)
        editing = False

        Set_SoundBankModifyed_Flag()
    End Sub

    Private Sub UpdateControls()
        For i As Integer = 0 To synth1.ParameterCount - 1
            UpdateControl(i, synth1.GetParameterValue(i))
        Next
    End Sub

    Private Sub UpdateControl(ByVal index As Integer, ByVal value As Single)
        If Single.IsNaN(value) Then Return
        updating = True
        Dim _control As Control = _controls(index)

        If TypeOf _control Is TrackBar Then
            Dim trackBar As TrackBar = DirectCast(_control, TrackBar)
            Dim range As Integer = trackBar.Maximum - trackBar.Minimum
            trackBar.Value = CInt(Math.Truncate(range * value + trackBar.Minimum))

        ElseIf TypeOf _control Is NumericUpDown Then
            Dim numericUpDown As NumericUpDown = DirectCast(_control, NumericUpDown)
            Dim range As Integer = CInt(numericUpDown.Maximum - numericUpDown.Minimum)

            numericUpDown.Value = CDec((range * value + CSng(numericUpDown.Minimum)))

        ElseIf TypeOf _control Is CheckBox Then
            Dim checkBox As CheckBox = DirectCast(_control, CheckBox)
            If value < 0.5 Then
                checkBox.Checked = False
            Else
                checkBox.Checked = True
            End If

        ElseIf TypeOf _control Is ComboBox Then
            Dim comboBox As ComboBox = DirectCast(_control, ComboBox)
            Dim count As Integer = comboBox.Items.Count
            comboBox.SelectedIndex = CInt(Math.Round((count - 1) * value))

        End If
        updating = False
    End Sub


End Class

